searchNodes=[{"ref":"Dinheiro.html","title":"Dinheiro","type":"module","doc":""},{"ref":"Dinheiro.html#compare/2","title":"Dinheiro.compare/2","type":"function","doc":"Compares two Dinheiro structs with each other. They must each be of the same currency and then their value are compared. Example: iex&gt; Dinheiro.compare(Dinheiro.new!(12345, :BRL), Dinheiro.new!(12345, :BRL)) {:ok, 0} iex&gt; Dinheiro.compare(Dinheiro.new!(12345, :BRL), Dinheiro.new!(12346, :BRL)) {:ok, -1} iex&gt; Dinheiro.compare(Dinheiro.new!(12346, :BRL), Dinheiro.new!(12345, :BRL)) {:ok, 1} iex&gt; Dinheiro.compare(Dinheiro.new!(12346, :USD), Dinheiro.new!(12346, :BRL)) {:error, &quot;currency :BRL different of :USD&quot;}"},{"ref":"Dinheiro.html#compare!/2","title":"Dinheiro.compare!/2","type":"function","doc":"Compares two Dinheiro structs with each other. They must each be of the same currency and then their value are compared. Example: iex&gt; Dinheiro.compare!(Dinheiro.new!(12345, :BRL), Dinheiro.new!(12345, :BRL)) 0 iex&gt; Dinheiro.compare!(Dinheiro.new!(12345, :BRL), Dinheiro.new!(12346, :BRL)) -1 iex&gt; Dinheiro.compare!(Dinheiro.new!(12346, :BRL), Dinheiro.new!(12345, :BRL)) 1 iex&gt; Dinheiro.compare!(Dinheiro.new!(12346, :USD), Dinheiro.new!(12346, :BRL)) ** (ArgumentError) currency :BRL different of :USD"},{"ref":"Dinheiro.html#divide/2","title":"Dinheiro.divide/2","type":"function","doc":"Divide a Dinheiro struct by a positive integer value Example: iex&gt; Dinheiro.divide(Dinheiro.new!(100, :BRL), 2) {:ok, [%Dinheiro{amount: 5000, currency: :BRL}, %Dinheiro{amount: 5000, currency: :BRL}]} iex&gt; Dinheiro.divide(%Dinheiro{amount: 5050, currency: :NONE}, 2) {:error, &quot;&#39;NONE&#39; does not represent an ISO 4217 code&quot;} Divide a Dinheiro struct by an list of values that represents a division ratio. Example: iex&gt; Dinheiro.divide(Dinheiro.new!(0.05, :BRL), [3, 7]) {:ok, [%Dinheiro{amount: 2, currency: :BRL}, %Dinheiro{amount: 3, currency: :BRL}]}"},{"ref":"Dinheiro.html#divide!/2","title":"Dinheiro.divide!/2","type":"function","doc":"Divide a Dinheiro struct by a positive integer value Example: iex&gt; Dinheiro.divide!(Dinheiro.new!(100, :BRL), 2) [%Dinheiro{amount: 5000, currency: :BRL}, %Dinheiro{amount: 5000, currency: :BRL}] iex&gt; Dinheiro.divide!(Dinheiro.new!(101, :BRL), 2) [%Dinheiro{amount: 5050, currency: :BRL}, %Dinheiro{amount: 5050, currency: :BRL}] iex&gt; Dinheiro.divide!(%Dinheiro{amount: 5050, currency: :NONE}, 2) ** (ArgumentError) &#39;NONE&#39; does not represent an ISO 4217 code Divide a Dinheiro struct by an list of values that represents a division ratio. Example: iex&gt; Dinheiro.divide!(Dinheiro.new!(0.05, :BRL), [3, 7]) [%Dinheiro{amount: 2, currency: :BRL}, %Dinheiro{amount: 3, currency: :BRL}]"},{"ref":"Dinheiro.html#equals?/2","title":"Dinheiro.equals?/2","type":"function","doc":"Retun true if two Dinheiro structs are equals. Example: iex&gt; Dinheiro.equals?(Dinheiro.new!(12345, :BRL), Dinheiro.new!(12345, :BRL)) true iex&gt; Dinheiro.equals?(Dinheiro.new!(12345, :BRL), Dinheiro.new!(12346, :BRL)) false iex&gt; Dinheiro.equals?(Dinheiro.new!(12345, :BRL), Dinheiro.new!(12345, :USD)) false"},{"ref":"Dinheiro.html#is_dinheiro?/1","title":"Dinheiro.is_dinheiro?/1","type":"function","doc":"Return if value is a Dinheiro struct. Example: iex&gt; Dinheiro.is_dinheiro?(%Dinheiro{amount: 200, currency: :BRL}) true iex&gt; Dinheiro.is_dinheiro?(%{amount: 200, currency: :BRL}) false iex&gt; Dinheiro.is_dinheiro?(200) false"},{"ref":"Dinheiro.html#multiply/2","title":"Dinheiro.multiply/2","type":"function","doc":"Return a new Dinheiro structs with value multiplied by other value. The first parameter must be a struct of Dinheiro. Example: iex&gt; Dinheiro.multiply(Dinheiro.new!(2, :BRL), 2) {:ok, %Dinheiro{amount: 400, currency: :BRL}} iex&gt; Dinheiro.multiply(2, 2) {:error, &quot;value must be a Dinheiro struct&quot;}"},{"ref":"Dinheiro.html#multiply!/2","title":"Dinheiro.multiply!/2","type":"function","doc":"Return a new Dinheiro structs with value multiplied by other value. The first parameter must be a struct of Dinheiro. Example: iex&gt; Dinheiro.multiply!(Dinheiro.new!(2, :BRL), 2) %Dinheiro{amount: 400, currency: :BRL} iex&gt; Dinheiro.multiply!(Dinheiro.new!(5, :BRL), 2.5) %Dinheiro{amount: 1250, currency: :BRL} iex&gt; Dinheiro.multiply!(Dinheiro.new!(4, :BRL), -2) %Dinheiro{amount: -800, currency: :BRL} iex&gt; Dinheiro.multiply!(2, 2) ** (ArgumentError) value must be a Dinheiro struct"},{"ref":"Dinheiro.html#new/1","title":"Dinheiro.new/1","type":"function","doc":"Create a new Dinheiro struct using a default currency. The default currency can be set in the system Mix config. Example: iex&gt; Application.put_env(:ex_dinheiro, :default_currency, :BRL) iex&gt; Dinheiro.new(12345) {:ok, %Dinheiro{amount: 1234500, currency: :BRL}} iex&gt; Dinheiro.new(&quot;1&quot;) {:error, &quot;value &#39;1&#39; must be integer or float&quot;} iex&gt; Application.delete_env(:ex_dinheiro, :default_currency) iex&gt; Dinheiro.new(12345) {:error, &quot;you must set a default value in your application config :ex_dinheiro, default_currency&quot;}"},{"ref":"Dinheiro.html#new/2","title":"Dinheiro.new/2","type":"function","doc":"Create a new Dinheiro struct. Example: iex&gt; Dinheiro.new(12345, :BRL) {:ok, %Dinheiro{amount: 1234500, currency: :BRL}} iex&gt; Dinheiro.new(&quot;1&quot;, :BRL) {:error, &quot;value &#39;1&#39; must be integer or float&quot;} iex&gt; Dinheiro.new(12345, :XBT) {:error, &quot;&#39;XBT&#39; does not represent an ISO 4217 code&quot;} iex&gt; currencies = %{ XBT: %Moeda{name: &quot;Bitcoin&quot;, symbol: &#39;฿&#39;, alpha_code: &quot;XBT&quot;, num_code: 0, exponent: 8} } iex&gt; Application.put_env(:ex_dinheiro, :unofficial_currencies, currencies) iex&gt; Dinheiro.new(123.45, :XBT) {:ok, %Dinheiro{amount: 12345000000, currency: :XBT}}"},{"ref":"Dinheiro.html#new!/1","title":"Dinheiro.new!/1","type":"function","doc":"Create a new Dinheiro struct using a default currency. The default currency can be set in the system Mix config. Example: iex&gt; Application.put_env(:ex_dinheiro, :default_currency, :BRL) iex&gt; Dinheiro.new!(12345) %Dinheiro{amount: 1234500, currency: :BRL} iex&gt; Dinheiro.new!(123.45) %Dinheiro{amount: 12345, currency: :BRL} iex&gt; Dinheiro.new!(&quot;1&quot;) ** (ArgumentError) value &#39;1&#39; must be integer or float"},{"ref":"Dinheiro.html#new!/2","title":"Dinheiro.new!/2","type":"function","doc":"Create a new Dinheiro struct. Example: iex&gt; Dinheiro.new!(12345, :BRL) %Dinheiro{amount: 1234500, currency: :BRL} iex&gt; Dinheiro.new!(12345, &quot;BRL&quot;) %Dinheiro{amount: 1234500, currency: :BRL} iex&gt; Dinheiro.new!(123.45, :BRL) %Dinheiro{amount: 12345, currency: :BRL} iex&gt; Dinheiro.new!(123.45, &quot;BRL&quot;) %Dinheiro{amount: 12345, currency: :BRL} iex&gt; Dinheiro.new!(12345, :NONE) ** (ArgumentError) &#39;NONE&#39; does not represent an ISO 4217 code Is possible to work with no official ISO currency code adding it in the system Mix config. Examples iex&gt; Moeda.find(:XBT) {:error, &quot;&#39;XBT&#39; does not represent an ISO 4217 code&quot;} iex&gt; currencies = %{ XBT: %Moeda{name: &quot;Bitcoin&quot;, symbol: &#39;฿&#39;, alpha_code: &quot;XBT&quot;, num_code: 0, exponent: 8} } iex&gt; Application.put_env(:ex_dinheiro, :unofficial_currencies, currencies) iex&gt; Dinheiro.new!(123.45, :XBT) %Dinheiro{amount: 12345000000, currency: :XBT}"},{"ref":"Dinheiro.html#subtract/2","title":"Dinheiro.subtract/2","type":"function","doc":"Return a new Dinheiro structs with subtract of two values. The first parameter must be a struct of Dinheiro. Example: iex&gt; Dinheiro.subtract(Dinheiro.new!(2, :BRL), Dinheiro.new!(1, :BRL)) {:ok, %Dinheiro{amount: 100, currency: :BRL}} iex&gt; Dinheiro.subtract(%Dinheiro{amount: 100, currency: :NONE}, 2) {:error, &quot;&#39;NONE&#39; does not represent an ISO 4217 code&quot;} iex&gt; Dinheiro.subtract(2, 2) {:error, &quot;value must be a Dinheiro struct&quot;} iex&gt; Dinheiro.subtract(Dinheiro.new!(2, :BRL), &quot;1&quot;) {:error, &quot;value &#39;1&#39; must be integer or float&quot;} iex&gt; Dinheiro.subtract(%Dinheiro{amount: 100, currency: :NONE}, %Dinheiro{amount: 100, currency: :NONE}) {:error, &quot;&#39;NONE&#39; does not represent an ISO 4217 code&quot;}"},{"ref":"Dinheiro.html#subtract!/2","title":"Dinheiro.subtract!/2","type":"function","doc":"Return a new Dinheiro structs with subtract of two values. The first parameter must be a struct of Dinheiro. Example: iex&gt; Dinheiro.subtract!(Dinheiro.new!(2, :BRL), Dinheiro.new!(1, :BRL)) %Dinheiro{amount: 100, currency: :BRL} iex&gt; Dinheiro.subtract!(Dinheiro.new!(4, :BRL), 2) %Dinheiro{amount: 200, currency: :BRL} iex&gt; Dinheiro.subtract!(Dinheiro.new!(5, :BRL), 2.5) %Dinheiro{amount: 250, currency: :BRL} iex&gt; Dinheiro.subtract!(Dinheiro.new!(4, :BRL), -2) %Dinheiro{amount: 600, currency: :BRL} iex&gt; Dinheiro.subtract!(%Dinheiro{amount: 100, currency: :NONE}, %Dinheiro{amount: 100, currency: :NONE}) ** (ArgumentError) &#39;NONE&#39; does not represent an ISO 4217 code"},{"ref":"Dinheiro.html#sum/1","title":"Dinheiro.sum/1","type":"function","doc":"Return a new Dinheiro structs with sum of a list of Dinheiro structs. Example: iex&gt; a = Dinheiro.new!(1, :BRL) iex&gt; b = Dinheiro.new!(1, :BRL) iex&gt; c = Dinheiro.new!(1, :BRL) iex&gt; d = Dinheiro.new!(1, :BRL) iex&gt; values = [a, b, c, d] iex&gt; Dinheiro.sum(values) {:ok, %Dinheiro{amount: 400, currency: :BRL}} The first item currency will be the result currency. Example: iex&gt; a = Dinheiro.new!(1, :BRL) iex&gt; b = Dinheiro.new!(1, :USD) iex&gt; c = Dinheiro.new!(1, :USD) iex&gt; d = Dinheiro.new!(1, :USD) iex&gt; e = Dinheiro.new!(1, :USD) iex&gt; Dinheiro.sum([a, b, c, d, e]) {:error, &quot;currency :USD different of :BRL&quot;} iex&gt; Dinheiro.sum([b, a, c, d, e]) {:error, &quot;currency :BRL different of :USD&quot;}"},{"ref":"Dinheiro.html#sum/2","title":"Dinheiro.sum/2","type":"function","doc":"Return a new Dinheiro structs with sum of two values. The first parameter must be a struct of Dinheiro. Example: iex&gt; Dinheiro.sum(Dinheiro.new!(2, :BRL), Dinheiro.new!(1, :BRL)) {:ok, %Dinheiro{amount: 300, currency: :BRL}} iex&gt; Dinheiro.sum(%Dinheiro{amount: 100, currency: :NONE}, 2) {:error, &quot;&#39;NONE&#39; does not represent an ISO 4217 code&quot;} iex&gt; Dinheiro.sum(2, 2) {:error, &quot;value must be a Dinheiro struct&quot;} iex&gt; Dinheiro.sum(Dinheiro.new!(2, :BRL), &quot;1&quot;) {:error, &quot;value &#39;1&#39; must be integer or float&quot;} iex&gt; Dinheiro.sum(%Dinheiro{amount: 100, currency: :NONE}, %Dinheiro{amount: 100, currency: :NONE}) {:error, &quot;&#39;NONE&#39; does not represent an ISO 4217 code&quot;}"},{"ref":"Dinheiro.html#sum!/1","title":"Dinheiro.sum!/1","type":"function","doc":"Return a new Dinheiro structs with sum of a list of Dinheiro structs. Example: iex&gt; a = Dinheiro.new!(1, :BRL) iex&gt; b = Dinheiro.new!(1, :BRL) iex&gt; c = Dinheiro.new!(1, :BRL) iex&gt; d = Dinheiro.new!(1, :BRL) iex&gt; values = [a, b, c, d] iex&gt; Dinheiro.sum!(values) %Dinheiro{amount: 400, currency: :BRL} The first item currency will be the result currency. Example: iex&gt; a = Dinheiro.new!(1, :BRL) iex&gt; b = Dinheiro.new!(1, :USD) iex&gt; c = Dinheiro.new!(1, :USD) iex&gt; d = Dinheiro.new!(1, :USD) iex&gt; e = Dinheiro.new!(1, :USD) iex&gt; values = [a, b, c, d, e] iex&gt; Dinheiro.sum!(values) ** (ArgumentError) currency :USD different of :BRL"},{"ref":"Dinheiro.html#sum!/2","title":"Dinheiro.sum!/2","type":"function","doc":"Return a new Dinheiro structs with sum of two values. The first parameter must be a struct of Dinheiro. Example: iex&gt; Dinheiro.sum!(Dinheiro.new!(1, :BRL), Dinheiro.new!(1, :BRL)) %Dinheiro{amount: 200, currency: :BRL} iex&gt; Dinheiro.sum!(Dinheiro.new!(1, :BRL), 2) %Dinheiro{amount: 300, currency: :BRL} iex&gt; Dinheiro.sum!(Dinheiro.new!(1, :BRL), 2.5) %Dinheiro{amount: 350, currency: :BRL} iex&gt; Dinheiro.sum!(Dinheiro.new!(2, :BRL), -1) %Dinheiro{amount: 100, currency: :BRL} iex&gt; Dinheiro.sum!(Dinheiro.new!(2, :BRL), &quot;1&quot;) ** (ArgumentError) value &#39;1&#39; must be integer or float"},{"ref":"Dinheiro.html#to_float/1","title":"Dinheiro.to_float/1","type":"function","doc":"Return a float value from a Dinheiro structs. Example: iex&gt; Dinheiro.to_float(%Dinheiro{amount: 200, currency: :BRL}) {:ok, 2.0} iex&gt; Dinheiro.to_float(%Dinheiro{amount: 200, currency: :NONE}) {:error, &quot;&#39;NONE&#39; does not represent an ISO 4217 code&quot;}"},{"ref":"Dinheiro.html#to_float!/1","title":"Dinheiro.to_float!/1","type":"function","doc":"Return a float value from a Dinheiro structs. Example: iex&gt; Dinheiro.to_float!(%Dinheiro{amount: 200, currency: :BRL}) 2.0 iex&gt; Dinheiro.to_float!(Dinheiro.new!(50.5, :BRL)) 50.5 iex&gt; Dinheiro.to_float!(Dinheiro.new!(-4, :BRL)) -4.0 iex&gt; Dinheiro.to_float!(%Dinheiro{amount: 200, currency: :NONE}) ** (ArgumentError) &#39;NONE&#39; does not represent an ISO 4217 code"},{"ref":"Dinheiro.html#to_string/2","title":"Dinheiro.to_string/2","type":"function","doc":"Return a formated string from a Dinheiro struct. Example: iex&gt; Dinheiro.to_string(%Dinheiro{amount: 200, currency: :BRL}) {:ok, &quot;R$ 2,00&quot;} iex&gt; Dinheiro.to_string(%Dinheiro{amount: 200, currency: :NONE}) {:error, &quot;&#39;NONE&#39; does not represent an ISO 4217 code&quot;}"},{"ref":"Dinheiro.html#to_string!/2","title":"Dinheiro.to_string!/2","type":"function","doc":"Return a formated string from a Dinheiro struct. Example: iex&gt; Dinheiro.to_string!(%Dinheiro{amount: 200, currency: :BRL}) &quot;R$ 2,00&quot; iex&gt; Dinheiro.to_string!(Dinheiro.new!(50.5, :BRL)) &quot;R$ 50,50&quot; iex&gt; Dinheiro.to_string!(Dinheiro.new!(-4, :BRL)) &quot;R$ -4,00&quot; iex&gt; Dinheiro.to_string!(%Dinheiro{amount: 200, currency: :NONE}) ** (ArgumentError) &#39;NONE&#39; does not represent an ISO 4217 code Using options-style parameters you can change the behavior of the function. thousand_separator - default &quot;.&quot;, sets the thousand separator. decimal_separator - default &quot;,&quot;, sets the decimal separator. display_currency_symbol - default true, put to false to hide de currency symbol. display_currency_code - default false, put to true to display de currency ISO 4217 code. Exemples iex&gt; Dinheiro.to_string!(Dinheiro.new!(1000.5, :USD), thousand_separator: &quot;,&quot;, decimal_separator: &quot;.&quot;) &quot;$ 1,000.50&quot; iex&gt; Dinheiro.to_string!(Dinheiro.new!(1000.5, :USD), display_currency_symbol: false) &quot;1.000,50&quot; iex&gt; Dinheiro.to_string!(Dinheiro.new!(1000.5, :USD), display_currency_code: true) &quot;$ 1.000,50 USD&quot; iex&gt; Dinheiro.to_string!(Dinheiro.new!(1000.5, :USD), display_currency_code: true, display_currency_symbol: false) &quot;1.000,50 USD&quot; The default values also can be set in the system Mix config. Example: iex&gt; Application.put_env(:ex_dinheiro, :thousand_separator, &quot;,&quot;) iex&gt; Application.put_env(:ex_dinheiro, :decimal_separator, &quot;.&quot;) iex&gt; Dinheiro.to_string!(Dinheiro.new!(1000.5, :USD)) &quot;$ 1,000.50&quot; iex&gt; Application.put_env(:ex_dinheiro, :display_currency_symbol, false) iex&gt; Dinheiro.to_string!(Dinheiro.new!(5000.5, :USD)) &quot;5,000.50&quot; iex&gt; Application.put_env(:ex_dinheiro, :display_currency_code, true) iex&gt; Dinheiro.to_string!(Dinheiro.new!(10000.0, :USD)) &quot;10,000.00 USD&quot; The options-style parameters override values in the system Mix config. Example: iex&gt; Application.put_env(:ex_dinheiro, :thousand_separator, &quot;,&quot;) iex&gt; Application.put_env(:ex_dinheiro, :decimal_separator, &quot;.&quot;) iex&gt; Dinheiro.to_string!(Dinheiro.new!(1000.5, :USD)) &quot;$ 1,000.50&quot; iex&gt; Dinheiro.to_string!(Dinheiro.new!(1000.5, :BRL), thousand_separator: &quot;.&quot;, decimal_separator: &quot;,&quot;) &quot;R$ 1.000,50&quot; Is possible to override some official ISO currency code adding it in the system Mix config. Examples iex&gt; Dinheiro.to_string!(Dinheiro.new!(12_345_678.9, :BRL)) &quot;R$ 12.345.678,90&quot; iex&gt; Dinheiro.to_string!(Dinheiro.new!(12_345_678.9, :USD)) &quot;$ 12.345.678,90&quot; iex&gt; Dinheiro.to_string!(%Dinheiro{amount: 200, currency: :XBT}) ** (ArgumentError) &#39;XBT&#39; does not represent an ISO 4217 code iex&gt; real = %Moeda{name: &quot;Moeda do Brasil&quot;, symbol: &#39;BR$&#39;, alpha_code: &quot;BRL&quot;, num_code: 986, exponent: 4} %Moeda{name: &quot;Moeda do Brasil&quot;, symbol: &#39;BR$&#39;, alpha_code: &quot;BRL&quot;, num_code: 986, exponent: 4} iex&gt; dollar = %Moeda{name: &quot;Moeda do EUA&quot;, symbol: &#39;US$&#39;, alpha_code: &quot;USD&quot;, num_code: 840, exponent: 3} %Moeda{name: &quot;Moeda do EUA&quot;, symbol: &#39;US$&#39;, alpha_code: &quot;USD&quot;, num_code: 840, exponent: 3} iex&gt; bitcoin = %Moeda{name: &quot;Bitcoin&quot;, symbol: &#39;฿&#39;, alpha_code: &quot;XBT&quot;, num_code: 0, exponent: 8} %Moeda{name: &quot;Bitcoin&quot;, symbol: &#39;฿&#39;, alpha_code: &quot;XBT&quot;, num_code: 0, exponent: 8} iex&gt; currencies = %{ BRL: real, USD: dollar, XBT: bitcoin } iex&gt; Application.put_env(:ex_dinheiro, :unofficial_currencies, currencies) iex&gt; Dinheiro.to_string!(Dinheiro.new!(12_345_678.9, :BRL)) &quot;BR$ 12.345.678,9000&quot; iex&gt; Dinheiro.to_string!(Dinheiro.new!(12_345_678.9, :usd)) &quot;US$ 12.345.678,900&quot; iex&gt; Dinheiro.to_string!(Dinheiro.new!(12_345_678.9, &quot;XBT&quot;)) &quot;฿ 12.345.678,90000000&quot;"},{"ref":"Dinheiro.html#t:t/0","title":"Dinheiro.t/0","type":"type","doc":"Type that represents Dinheiro struct with: :amount as integer that represents an amount. :currency as atom that represents an ISO 4217 code."},{"ref":"Moeda.html","title":"Moeda","type":"module","doc":""},{"ref":"Moeda.html#find/1","title":"Moeda.find/1","type":"function","doc":"Return a map from an atom or string that represents an ISO 4217 code. Examples iex&gt; Moeda.find(:BRL) {:ok, %Moeda{name: &quot;Brazilian Real&quot;, symbol: &#39;R$&#39;, alpha_code: &quot;BRL&quot;, num_code: 986, exponent: 2}} iex&gt; Moeda.find(&quot;BRL&quot;) {:ok, %Moeda{name: &quot;Brazilian Real&quot;, symbol: &#39;R$&#39;, alpha_code: &quot;BRL&quot;, num_code: 986, exponent: 2}} iex&gt; Moeda.find(986) {:ok, %Moeda{name: &quot;Brazilian Real&quot;, symbol: &#39;R$&#39;, alpha_code: &quot;BRL&quot;, num_code: 986, exponent: 2}} iex&gt; Moeda.find(&quot;NONE&quot;) {:error, &quot;&#39;NONE&#39; does not represent an ISO 4217 code&quot;} Its function ignore case sensitive. Examples iex&gt; Moeda.find(:brl) {:ok, %Moeda{name: &quot;Brazilian Real&quot;, symbol: &#39;R$&#39;, alpha_code: &quot;BRL&quot;, num_code: 986, exponent: 2}} iex&gt; Moeda.find(&quot;brl&quot;) {:ok, %Moeda{name: &quot;Brazilian Real&quot;, symbol: &#39;R$&#39;, alpha_code: &quot;BRL&quot;, num_code: 986, exponent: 2}} Is possible to work with no official ISO currency code adding it in the system Mix config. Examples iex&gt; Moeda.find(:XBT) {:error, &quot;&#39;XBT&#39; does not represent an ISO 4217 code&quot;} iex&gt; currencies = %{ XBT: %Moeda{name: &quot;Bitcoin&quot;, symbol: &#39;฿&#39;, alpha_code: &quot;XBT&quot;, num_code: 0, exponent: 8} } iex&gt; Application.put_env(:ex_dinheiro, :unofficial_currencies, currencies) iex&gt; Moeda.find(&quot;xbt&quot;) {:ok, %Moeda{name: &quot;Bitcoin&quot;, symbol: &#39;฿&#39;, alpha_code: &quot;XBT&quot;, num_code: 0, exponent: 8}} Is possible to override some official ISO currency code adding it in the system Mix config. Examples iex&gt; Moeda.find(:BRL) {:ok, %Moeda{name: &quot;Brazilian Real&quot;, symbol: &#39;R$&#39;, alpha_code: &quot;BRL&quot;, num_code: 986, exponent: 2}} iex&gt; currencies = %{ BRL: %Moeda{name: &quot;Moeda do Brasil&quot;, symbol: &#39;BR$&#39;, alpha_code: &quot;BRL&quot;, num_code: 986, exponent: 4}, USD: %Moeda{name: &quot;Moeda do EUA&quot;, symbol: &#39;US$&#39;, alpha_code: &quot;USD&quot;, num_code: 986, exponent: 3} } iex&gt; Application.put_env(:ex_dinheiro, :unofficial_currencies, currencies) iex&gt; Moeda.find(:BRL) {:ok, %Moeda{name: &quot;Moeda do Brasil&quot;, symbol: &#39;BR$&#39;, alpha_code: &quot;BRL&quot;, num_code: 986, exponent: 4}} iex&gt; Moeda.find(:USD) {:ok, %Moeda{name: &quot;Moeda do EUA&quot;, symbol: &#39;US$&#39;, alpha_code: &quot;USD&quot;, num_code: 986, exponent: 3}} iex&gt; Application.delete_env(:ex_dinheiro, :unofficial_currencies) iex&gt; Moeda.find(:BRL) {:ok, %Moeda{name: &quot;Brazilian Real&quot;, symbol: &#39;R$&#39;, alpha_code: &quot;BRL&quot;, num_code: 986, exponent: 2}} Be careful setting new currencies to Mix config. Examples iex&gt; Moeda.find(:XBT) {:error, &quot;&#39;XBT&#39; does not represent an ISO 4217 code&quot;} iex&gt; currencies = %{ XBT: %{name: &quot;Bitcoin&quot;, symbol: &#39;฿&#39;, alpha_code: &quot;XBT&quot;, num_code: 0, exponent: 8} } iex&gt; Application.put_env(:ex_dinheiro, :unofficial_currencies, currencies) iex&gt; Moeda.find(:XBT) {:error, &quot;&#39;XBT&#39; does not represent an ISO 4217 code&quot;} iex&gt; currencies = %{ XBT: %Moeda{name: &quot;Bitcoin&quot;, symbol: &#39;฿&#39;, alpha_code: &quot;XBT&quot;, num_code: 0, exponent: 8} } iex&gt; Application.put_env(:ex_dinheiro, :unofficial_currencies, currencies) iex&gt; Moeda.find(&quot;xbt&quot;) {:ok, %Moeda{name: &quot;Bitcoin&quot;, symbol: &#39;฿&#39;, alpha_code: &quot;XBT&quot;, num_code: 0, exponent: 8}}"},{"ref":"Moeda.html#find!/1","title":"Moeda.find!/1","type":"function","doc":"Return a map from an atom or string that represents an ISO 4217 code. Examples iex&gt; Moeda.find!(:BRL) %Moeda{name: &quot;Brazilian Real&quot;, symbol: &#39;R$&#39;, alpha_code: &quot;BRL&quot;, num_code: 986, exponent: 2} iex&gt; Moeda.find!(986) %Moeda{name: &quot;Brazilian Real&quot;, symbol: &#39;R$&#39;, alpha_code: &quot;BRL&quot;, num_code: 986, exponent: 2} iex&gt; Moeda.find!(:NONE) ** (ArgumentError) &#39;NONE&#39; does not represent an ISO 4217 code"},{"ref":"Moeda.html#get_atom/1","title":"Moeda.get_atom/1","type":"function","doc":"Return an atom from a value that represents an ISO 4217 code. Examples iex&gt; Moeda.get_atom(:BRL) {:ok, :BRL} iex&gt; Moeda.get_atom(:NONE) {:error, &quot;&#39;NONE&#39; does not represent an ISO 4217 code&quot;}"},{"ref":"Moeda.html#get_atom!/1","title":"Moeda.get_atom!/1","type":"function","doc":"Return an atom from a value that represents an ISO 4217 code. Examples iex&gt; Moeda.get_atom!(:BRL) :BRL iex&gt; Moeda.get_atom!(&quot;BRL&quot;) :BRL iex&gt; Moeda.get_atom!(:NONE) ** (ArgumentError) &#39;NONE&#39; does not represent an ISO 4217 code Its function ignore case sensitive. Examples iex&gt; Moeda.get_atom!(:brl) :BRL iex&gt; Moeda.get_atom!(&quot;brl&quot;) :BRL"},{"ref":"Moeda.html#get_factor/1","title":"Moeda.get_factor/1","type":"function","doc":"Return a multiplication factor from an ISO 4217 code. Examples iex&gt; Moeda.get_factor(:BRL) {:ok, 100.0} iex&gt; Moeda.get_factor(:NONE) {:error, &quot;&#39;NONE&#39; does not represent an ISO 4217 code&quot;}"},{"ref":"Moeda.html#get_factor!/1","title":"Moeda.get_factor!/1","type":"function","doc":"Return a multiplication factor from an ISO 4217 code. Examples iex&gt; Moeda.get_factor!(:BRL) 100.0 iex&gt; Moeda.get_factor!(&quot;BRL&quot;) 100.0 iex&gt; Moeda.get_factor!(:NONE) ** (ArgumentError) &#39;NONE&#39; does not represent an ISO 4217 code Its function ignore case sensitive. Examples iex&gt; Moeda.get_factor!(:brl) 100.0 iex&gt; Moeda.get_factor!(&quot;brl&quot;) 100.0"},{"ref":"Moeda.html#to_string/3","title":"Moeda.to_string/3","type":"function","doc":"Return a formated string from a ISO 4217 code and a float value. Examples iex&gt; Moeda.to_string(:BRL, 100.0) {:ok, &quot;R$ 100,00&quot;} iex&gt; Moeda.to_string(:NONE, 1000.5) {:error, &quot;&#39;NONE&#39; does not represent an ISO 4217 code&quot;}"},{"ref":"Moeda.html#to_string!/3","title":"Moeda.to_string!/3","type":"function","doc":"Return a formated string from a ISO 4217 code and a float value. Examples iex&gt; Moeda.to_string!(:BRL, 100.0) &quot;R$ 100,00&quot; iex&gt; Moeda.to_string!(&quot;BRL&quot;, 1000.5) &quot;R$ 1.000,50&quot; iex&gt; Moeda.to_string!(:BRL, -1.0) &quot;R$ -1,00&quot; iex&gt; Moeda.to_string!(:NONE, 1000.5) ** (ArgumentError) &#39;NONE&#39; does not represent an ISO 4217 code Its function ignore case sensitive. Examples iex&gt; Moeda.to_string!(:bRl, 100.0) &quot;R$ 100,00&quot; iex&gt; Moeda.to_string!(&quot;BrL&quot;, 1000.5) &quot;R$ 1.000,50&quot; Using options-style parameters you can change the behavior of the function. thousand_separator - default &quot;.&quot;, set the thousand separator. decimal_separator - default &quot;,&quot;, set the decimal separator. display_currency_symbol - default true, put to false to hide de currency symbol. display_currency_code - default false, put to true to display de currency ISO 4217 code. Exemples iex&gt; Moeda.to_string!(:USD, 1000.5, thousand_separator: &quot;,&quot;, decimal_separator: &quot;.&quot;) &quot;$ 1,000.50&quot; iex&gt; Moeda.to_string!(:USD, 1000.5, display_currency_symbol: false) &quot;1.000,50&quot; iex&gt; Moeda.to_string!(:USD, 1000.5, display_currency_code: true) &quot;$ 1.000,50 USD&quot; iex&gt; Moeda.to_string!(:USD, 1000.5, display_currency_code: true, display_currency_symbol: false) &quot;1.000,50 USD&quot; The default values also can be set in the system Mix config. Example: iex&gt; Application.put_env(:ex_dinheiro, :thousand_separator, &quot;,&quot;) iex&gt; Application.put_env(:ex_dinheiro, :decimal_separator, &quot;.&quot;) iex&gt; Moeda.to_string!(:USD, 1000.5) &quot;$ 1,000.50&quot; iex&gt; Application.put_env(:ex_dinheiro, :display_currency_symbol, false) iex&gt; Moeda.to_string!(:USD, 5000.5) &quot;5,000.50&quot; iex&gt; Application.put_env(:ex_dinheiro, :display_currency_code, true) iex&gt; Moeda.to_string!(:USD, 10000.0) &quot;10,000.00 USD&quot; The options-style parameters override values in the system Mix config. Example: iex&gt; Application.put_env(:ex_dinheiro, :thousand_separator, &quot;,&quot;) iex&gt; Application.put_env(:ex_dinheiro, :decimal_separator, &quot;.&quot;) iex&gt; Moeda.to_string!(:USD, 1000.5) &quot;$ 1,000.50&quot; iex&gt; Moeda.to_string!(:BRL, 1000.5, thousand_separator: &quot;.&quot;, decimal_separator: &quot;,&quot;) &quot;R$ 1.000,50&quot;"},{"ref":"Moeda.html#t:t/0","title":"Moeda.t/0","type":"type","doc":"Type that represents Moeda struct with: :name as String.t that represents the name of the currency. :symbol as String.t that represents symbol of the currency. :alpha_code as String.t that represents the alphabetic ISO 4217 code. :num_code as integer that represents the numeric ISO 4217 code. Where possible the 3 digit numeric code is the same as the numeric country code. :exponent as integer that represents the exponent of the currency."},{"ref":"readme.html","title":"ex_dinheiro","type":"extras","doc":"ex_dinheiro master: dev: Elixir library for money manipulation."},{"ref":"readme.html#installation","title":"ex_dinheiro - Installation","type":"extras","doc":"This package can be installed by adding :ex_dinheiro to your list of dependencies in mix.exs: def deps do [ {:ex_dinheiro, &quot;~&gt; 0.2.1&quot;} ] end Documentation can be found at https://hexdocs.pm/ex_dinheiro."},{"ref":"changelog.html","title":"CHANGELOG","type":"extras","doc":""},{"ref":"changelog.html#changelog","title":"CHANGELOG - Changelog","type":"extras","doc":"v0.3.0 Add find by num_code to Moeda module. v0.2.1 Refactoring for better understanding and compliance to the ISO 4217 standard. v0.2.0 Implementation of the methods sum/1 and sum!/1. v0.1.9 Refactoring to raising exceptions with no trailing punctuation to suit the Elixir conventions. v0.1.8 Implementation of the method is_dinheiro?/1. Implementation of build and build_travis tasks. Refactoring of .travis.yml to run build_travis task. Adding CHANGELOG.md on :ex_dinheiro documentation. v0.1.7 Update of the documentation and more test cases added. Refactoring to suit the Elixir conventions. Changed self-references to MODULE. Returns changed to {:ok, result} and {:error, reason} in Dinheiro module: compare/2 divide/2 multiply/2 new/1 new/2 subtract/2 sum/2 to_float/1 to_string/2 Functions that returns the unwrapped result or raises an error in Dinheiro module. compare!/2 divide!/2 multiply!/2 new!/1 new!/2 subtract!/2 sum!/2 to_float!/1 to_string!/2 Returns changed to {:ok, result} and {:error, reason} in Moeda module: find/1 get_atom/1 get_factor/1 to_string/3 Functions that returns the unwrapped result or raises an error in Moeda module. find!/1 get_atom!/1 get_factor!/1 to_string!/3 v0.1.6 Refector of the code: Creation of a bag of currencies Moeda.Moedas to separate the logic to manipulate currencies of the repository of them. Change the lines length to 80 in .formatter.exs to compliance with credo. Update of documentation: Adding more exemples. Adding badge of Travis.CI. Adding badge of Coveralls.IO. v0.1.5 New feactures to permit: Compliance with ISO 4217. To work with no official ISO currency code adding it in the system Mix config. To override some official ISO currency code adding it in the system Mix config. Implementation of the method equals?/2. v0.1.4 Implementation of the wrapper method to_string/2. Refactor of the method to_float/1. v0.1.3 Implementation of the method to_string/3. Refactor to normalize the code to de credo patterns. v0.1.2 Implementation of the methods: compare/2 divide/2 multiply/2 new/1 new/2 subtract/2 sum/2 to_float/1 v0.1.1 Configuration of Continuous Integration, Delivery, and Deployment. v0.1.0 Library creation."}]